/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.muni.fi.cepportal.cepserver;


import cz.muni.fi.cepportal.jms.JMSContext;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import javax.jms.DeliveryMode;
import javax.jms.JMSException;
import javax.jms.MessageProducer;
import javax.jms.TextMessage;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
 * This class sends responses from server to web client via JMS.
 * 
 * @author Štefan Repček
 */
public class ServerResponseMessager {
    
    
    JMSContext jmscontext;
    private static Log log = LogFactory.getLog(XMLEventMessageListener.class);
    
    
    public ServerResponseMessager(JMSContext jmscontext)
    {
        this.jmscontext = jmscontext;
    }
    
    
    public void sendResponse(String msg) 
    {
       try{ 
        MessageProducer producer = jmscontext.getSession().createProducer(jmscontext.getClientDestination());
        TextMessage textMessage  = jmscontext.getSession().createTextMessage();
        Calendar cal = Calendar.getInstance();
        DateFormat dateFormat = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss: ");
        textMessage.setText(dateFormat.format(cal.getTime()) + msg);
        textMessage.setJMSDeliveryMode(DeliveryMode.NON_PERSISTENT);
        producer.send(textMessage);
        log.info("response sent");
       }
       catch(JMSException ex)
       {
           log.error(ex);
       }
    }
    
}
