/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.muni.fi.cepportal.cepserver;

import com.espertech.esper.client.EPRuntime;
import com.espertech.esper.client.EPServiceProvider;
import com.espertech.esper.event.EventAdapterException;
import java.io.IOException;
import java.io.StringReader;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.TextMessage;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.w3c.dom.Document;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

/**
 * This class represents Listener, which catches event messages from 
 * web clients and sends it to engine Esper
 * 
 * @author Štefan Repček
 */
public class XMLEventMessageListener implements MessageListener {

    private static Log log = LogFactory.getLog(XMLEventMessageListener.class);
    private EPServiceProvider engine;
    ServerResponseMessager responseMessager;

    public XMLEventMessageListener(EPServiceProvider engine ,ServerResponseMessager responseMessager ) {
        this.engine = engine;
        this.responseMessager = responseMessager;
    }
    
    @Override
    public void onMessage(Message msg) {
     
        TextMessage textMessage = (TextMessage) msg;
        try {
            String event = textMessage.getText();
            InputSource s = new InputSource(new StringReader(event));
            DocumentBuilderFactory builderFactory = DocumentBuilderFactory.newInstance();

            Document xmlEvent = builderFactory.newDocumentBuilder().parse(s);
            try{
            log.info("event with root "+xmlEvent.getFirstChild().getNodeName() +"  send to Esper");
            responseMessager.sendResponse("event with root " +xmlEvent.getFirstChild().getNodeName() +" send to Esper");
            engine.getEPRuntime().sendEvent(xmlEvent);
            
            
            }
            catch(EventAdapterException ex)
            {
              log.error(ex);
              responseMessager.sendResponse("Event with root: "+xmlEvent.getFirstChild().getNodeName() + " has not been registered");
            }

        } catch (JMSException | SAXException | IOException | ParserConfigurationException ex) {
            log.error(ex);
            responseMessager.sendResponse(ex.getMessage());
        }
        
    }
    
}
