/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.muni.fi.cepportal.jms;

import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.Destination;
import javax.jms.JMSException;
import javax.jms.Session;

/**
 * This class store important values which are needed for sending messages via JMS
 * 
 * @author Štefan Repček
 */
public class JMSContext {
    
   
    private ConnectionFactory factory;
    private Connection connection;
    private Session session;
    private Destination serverDestination;
    private Destination clientDestination;

    public JMSContext(ConnectionFactory factory, Connection connection, Session session, Destination serverDestination, Destination clientDestination )
    {
        this.factory = factory;
        this.connection = connection;
        this.session = session;
        this.serverDestination = serverDestination;
        this.clientDestination = clientDestination;
    }

    public void destroy() throws JMSException
    {
        session.close();
        connection.close();
    }

    public Connection getConnection()
    {
        return connection;
    }

    public Destination getServerDestination() {
        return serverDestination;
    }

    public Destination getClientDestination() {
        return clientDestination;
    }

   

    public ConnectionFactory getFactory()
    {
        return factory;
    }

    public Session getSession()
    {
        return session;
    }
}
    

