/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.muni.fi.cepportal.database.dao.impl;

import cz.muni.fi.cepportal.database.dao.CEPOutputDAO;
import cz.muni.fi.cepportal.database.entities.CEPOutput;
import cz.muni.fi.cepportal.database.exceptions.NonexistentEntityException;
import cz.muni.fi.cepportal.database.exceptions.PreexistingEntityException;
import java.io.Serializable;
import java.util.List;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;
import org.springframework.stereotype.Repository;

/**
 * This class realises CRUD operations with CEPOutput entity.
 * 
 * @author Štefan Repček
 */
@Repository
public class CEPOutputDAOImpl implements CEPOutputDAO,Serializable{

    
     @PersistenceContext(unitName="CEPPortalPU")
     private EntityManager em;

     public void setEm(EntityManager em) {
        this.em = em;
     }
    
    @Override
    public void createCEPOutput(CEPOutput cepOutput) {
        if(cepOutput == null)
        {
            throw new IllegalArgumentException("CEPOutput is null");
        }
        em.persist(cepOutput);
    }

    @Override
    public void updateCEPOutput(CEPOutput cepOutput)  {
        if(cepOutput == null)
        {
            throw new IllegalArgumentException("cep output  is null");
        }
        em.merge(cepOutput);
    }

    @Override
    public void deleteCEPOutput(CEPOutput cepOutput) throws NonexistentEntityException {
        if(cepOutput == null)
        {
            throw new IllegalArgumentException("cepoutput is null");
        }
         if(this.getCEPOutputByID(cepOutput.getId()) == null)
        {
            throw new NonexistentEntityException("cepoutput with name " + cepOutput.getName() + " doesnt exist" );
        }
         em.remove(em.merge(cepOutput));
    }

    @Override
    public CEPOutput getCEPOutputByID(Long id) {
        if(id == null)
        {
            throw new IllegalArgumentException("id is null");
        }
        return em.find(CEPOutput.class,id);
    }

    @Override
    public CEPOutput findCEPOutputByName(String name) {
        Query q = em.createQuery("select object(o) from CEPOutput as o where o.name='"+ name + "'");
      
        
        List<CEPOutput> list = q.getResultList();
        if(list.isEmpty())
        {
            return null;
        }
        else
        {
            return list.get(0);
        }
    }

    @Override
    public List<CEPOutput> findAllCEPOutputs() {
        Query q = em.createQuery("select object(o) from CEPOutput as o");
        return q.getResultList();
    }
    
}
